data {
    int N;
    real RT[N];
    real min_mu;
    real max_mu;
    real max_sgm;
}
parameters {
    real<lower = min_mu, upper = max_mu> mu;
    real<lower = 0.0, upper = max_sgm> sgm;
}
model {
    mu ~ uniform(min_mu, max_mu);
    sgm ~ uniform(0.0, max_sgm);
    for(i in 1:N){
        RT[i] ~ normal(mu, sgm);
    }
}
