import math, numpy, random
from psychopy import core, event, visual, gui
import psychopy.sound.backend_ptb as pss 

myWin = visual.Window(size=(500, 300), pos=None, color='black', 
            colorSpace='rgb', 
            rgb=None, dkl=None, lms=None, fullscr=False, allowGUI=True, 
            monitor=None, bitsMode=None, winType=None, units='pix', 
            gamma=None, blendMode='avg', screen=0, viewScale=None, 
            viewPos=None, viewOri=0.0, waitBlanking=True, allowStencil=False, 
            multiSample=False, numSamples=2, stereo=False, name='window1', 
            checkTiming=True, useFBO=False, useRetina=True, autoLog=True, 
            gammaErrorPolicy='raise', bpc=(8, 8, 8), depthBits=8,
            stencilBits=8, backendConf=None) 
                        
myClock = core.Clock()

print('size = ', myWin.size)

mySound = pss.SoundPTB(value = 2000, secs = 0.5, volume = 1.0)

latencies = []

for i in range(5):
    t = 2.0 * (1.2**i)
    latencies.append(t)
    
g_latencies = []
for i in range(40):
    numpy.random.shuffle(latencies)
    g_latencies = g_latencies + latencies
    
print('g_latnecies = ', g_latencies)

n_trials = 100           #   Total number of trials
RTs = numpy.empty(n_trials)
Intvls = numpy.empty(n_trials)
    
information = visual.TextStim(myWin, text = '', height = 24, color = 'white')

t = 1
pos_g_latencies = 0
while True:
    #           第t試行
    mySound.play()
        
    msg = '{0}/{1}'.format(t, n_trials) + \
          '\nPress the Z key, \nwhen youv are ready.' + \
          '\n\nAfter some seconds, \nthe character M will be presented.' + \
          '\n\nPress the M key as fast as possible \nwhen M appears.'
    
    information.setText(msg)
    information.setHeight(24)
    information.draw()
    
    myWin.flip()
    
    event.clearEvents()
    while True:
        pressedList = event.getKeys(keyList = ['z'])
        if len(pressedList) > 0:
            if pressedList[0] == 'z':  #    試行開始
                event.clearEvents()
                break
    myWin.flip()    
    
    t1 = myClock.getTime()
    flying = False
    while True:
        pressedList = event.getKeys(keyList = ['m'])
        if len(pressedList) > 0:
            if pressedList[0] == 'm':       #   フライング
                flying = True
                information.setText('Flying')
                information.draw()
                myWin.flip()
                core.wait(2)
                event.clearEvents()
                pos_g_latencies += 1
                break
            event.clearEvents()
        if myClock.getTime() > t1 + g_latencies[pos_g_latencies]:
            break
                    
            
    if flying == True:
        continue
        
    information.setText('M')
    information.setHeight(48)
    information.draw()
    myWin.flip()
    event.clearEvents()
    t1 = myClock.getTime()      #   刺激提示時刻
    t2 = None
    while True:
        pressedList = event.getKeys(keyList = ['m'])
        if len(pressedList) > 0:
            if pressedList[0] == 'm':
                t2 = myClock.getTime()  #   反応時刻
                break
                
    myWin.flip()
    core.wait(2)
    RTs[t-1] = t2 - t1          #   反応時間
    Intvls[t-1] = g_latencies[pos_g_latencies]
    t += 1
    pos_g_latencies += 1
    if pos_g_latencies >= len(g_latencies):
        pos_g_latnecies = 0
    if t > n_trials:
        break
    
#
#           反応時間の出力と保存
#
myWin.close()
for i in range(n_trials):
    print('RT: ', RTs[i], '   Intvl: ', Intvls[i])
    
flnm = gui.fileSaveDlg(prompt = u'出力ファイル名(*.txt)')
print('file name = ', flnm)
fout = open(flnm, 'w')
fout.write('/\n')
fout.write('{0:>10s}{1:>10s}\n'.format('RT', 'Interval'))
for i in range(n_trials):
    fout.write('{0:>10.5f}{1:>10.5f}\n'.format(RTs[i], Intvls[i]))
fout.write('/\n')
fout.close()
print(flnm, ' was saved.')
core.quit()

